<template>
  <div id="users">
    <v-container fluid>
      <v-row class="d-flex justify-center mt-5">
        <v-card class="mt-8 elevation-8 mx-auto mb-7" style="width: 90%">
          <v-card-title class="d-block text-center pt-6 pb-5 text-h4">
            Utenti
          </v-card-title>
          <v-card-text>
            <v-data-table
                hide-default-footer
                :items="users"
                :headers="headers"
                item-key="item.id"
            >
              <template v-slot:top>
                <v-toolbar
                    flat
                >
                  <v-btn
                      color="primary"
                      dark
                      rounded
                      class="mb-2"
                      @click="dialog = true"
                  >
                    <v-icon small>fas fa-user-plus</v-icon>
                  </v-btn>
                </v-toolbar>
              </template>
              <template v-slot:item.actions="{ item }">
                <v-icon
                    small
                    color="primary"
                    class="mx-2"
                    @click="editUserPopup(item)"
                >
                  fas fa-edit
                </v-icon>
                <v-icon
                    small
                    color="primary"
                    class="mx-2"
                    @click="deleteUser(item)"
                >
                  fas fa-trash
                </v-icon>
              </template>
            </v-data-table>
          </v-card-text>
        </v-card>
      </v-row>
    </v-container>
    <v-dialog
        v-model="dialog"
        width="50%"
        @click:outside="closeDialog"
        @close="closeDialog"
    >
      <v-card class="pt-10">
        <v-card-text>
            <v-text-field
                id="name"
                label="Nome"
                name="name"
                v-model="user.name"
                outlined
                prepend-icon="fas fa-user"
                type="text"
            ></v-text-field>
            <v-text-field
                id="surname"
                label="Cognome"
                name="surname"
                v-model="user.surname"
                outlined
                prepend-icon="fas fa-user"
                type="text"
            ></v-text-field>
            <v-text-field
                label="Email"
                name="email"
                type="email"
                v-model="user.email"
                outlined
                prepend-icon="fas fa-user"
            ></v-text-field>
        </v-card-text>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn color="primary" @click="userToEditId !== null ? editUser() : createAdminUser()">
            Salva
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
  </div>

</template>

<script>
export default {
  name: "Users",
  data () {
    return {
      headers: [
        { value: 'id', text: 'Id'},
        { value: 'name', text: 'Nome'},
        { value: 'surname', text: 'Cognome'},
        { value: 'email', text: 'E-mail'},
        { value: 'admin', text: 'Amministratore'},
        { text: 'Actions', value: 'actions', sortable: false }
      ],
      users: [],
      dialog: false,
      user: {
        name: null,
        surname: null,
        email: null
      },
      userToEditId: null
    }
  },
  mounted() {
    this.getUsers()
  },
  methods: {
    async getUsers () {
      let response = await this.$http.get('/users');
      this.users = response.data;
    },
    async deleteUser(item) {
      if(window.confirm("Sei sicuro di voler eliminare " + item.name + "?")) {
        await this.$http.delete('/users/' + item.id)
        await this.getUsers()
      }
      else
        window.alert('Menomale, poverino!')

    },
    async createAdminUser() {
      try {
        console.log('creo ' + this.user.name)
        await this.$http.post('/users/admin', this.user)
      } catch (error) {
        window.alert('Errore nella creazione!')
      } finally {
        await this.closeDialog()
      }
    },
    async editUser() {
      try {
        await this.$http.put('/users/' + this.userToEditId, this.user)
      } catch (error) {
        window.alert('Errore nella creazione!')
      } finally {
        await this.closeDialog()
      }
    },
    editUserPopup(item) {
      this.user.email = item.email;
      this.user.name = item.name;
      this.user.surname = item.surname;
      this.userToEditId = item.id;
      this.dialog = true;
    },
    async closeDialog() {
      this.resetUser();
      this.dialog = false;
      await this.getUsers()
    },
    resetUser() {
      Object.keys(this.user).forEach((k) => this.user[k] = null)
      this.userToEditId = null
    }
  }
}
</script>

<style scoped>

</style>
